"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
exports.__esModule = true;
exports.default = void 0;
var _modern = require("@swagger-api/apidom-json-pointer/modern");
var _CompilationRelativeJsonPointerError = _interopRequireDefault(require("./errors/CompilationRelativeJsonPointerError.cjs"));
/**
 * @public
 */
const compile = relativeJsonPointer => {
  try {
    let relativePointer = '';

    // non-negative-integer
    relativePointer += String(relativeJsonPointer.nonNegativeIntegerPrefix);

    // index-manipulation
    if (typeof relativeJsonPointer.indexManipulation === 'number') {
      relativePointer += String(relativeJsonPointer.indexManipulation);
    }
    if (Array.isArray(relativeJsonPointer.jsonPointerTokens)) {
      // <json-pointer>
      relativePointer += (0, _modern.compile)(relativeJsonPointer.jsonPointerTokens);
    } else if (relativeJsonPointer.hashCharacter) {
      // "#"
      relativePointer += '#';
    }
    return relativePointer;
  } catch (error) {
    throw new _CompilationRelativeJsonPointerError.default('Relative JSON Pointer compilation encountered an error.', {
      relativePointer: relativeJsonPointer,
      cause: error
    });
  }
};
var _default = exports.default = compile;